DECLARE @nVersion INT, @stmt NVARCHAR(1024), @params NVARCHAR(128)
IF (OBJECTPROPERTY(OBJECT_ID('xp_getbuildnumber'),'IsExtendedProc') = 1)
	BEGIN
	     
		CREATE TABLE #ttt([buildnumber] INT)
		INSERT INTO #ttt([buildnumber]) EXEC master..xp_getbuildnumber
		SELECT @nVersion = [buildnumber] FROM #ttt
		DROP TABLE #ttt

		IF (@nVersion < 106)
			BEGIN
				SET @stmt = N'
					 IF OBJECTPROPERTY(OBJECT_ID(@proc),''IsExtendedProc'') = 1
					 EXECUTE SP_DROPEXTENDEDPROC @proc
					 EXECUTE SP_ADDEXTENDEDPROC @proc, ''xpks01.dll''
					 IF @public = 1 EXECUTE (''GRANT EXECUTE ON '' + @proc + '' TO PUBLIC'')
							 '
				SET @params = N'@proc VARCHAR(64), @public BIT = 0'
				--new
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_logincomplex',	1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_logindbconnect',	1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_logindbdisconnect',	1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_navigator',	 	1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_logindbobjects', 	1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getnewhash', 	1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_setnewkey', 		1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_setnewkey01', 		1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getexpiredcomplexes',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getlicenseinfo01',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getbuildnumber01',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_checkkey01',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_checkdate01',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getupdatedate',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_getkey',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_userinfo',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_getexpdate',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_getenddate',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_get_obj_access',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_setkey',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_getconfig',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_getsubconfig',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'ExtractKeyParams',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'CreateSignature',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_checkdigt',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_checkdigt01',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getvernumber',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_decrypt_r',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_ed2sql',		1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_sklonstr',		1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_sklonadd',		1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getlicenseinfo02',1
				EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getxmlver',1
			END
			ELSE
				GOTO full_install
	END
ELSE
	BEGIN  -- the first installation of XPKS
full_install:
		SET @stmt = N'
			IF OBJECTPROPERTY(OBJECT_ID(@proc),''IsExtendedProc'') = 1
			EXECUTE SP_DROPEXTENDEDPROC @proc
			EXECUTE SP_ADDEXTENDEDPROC @proc, ''xpks01.dll''
			IF @public = 1 EXECUTE (''GRANT EXECUTE ON '' + @proc + '' TO PUBLIC'')
                '
		SET @params = N'@proc VARCHAR(64), @public BIT = 0'
		--new
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_logincomplex',	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_logindbconnect',	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_logindbdisconnect',	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_navigator', 	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_logindbobjects', 	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getnewhash', 	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_setnewkey', 	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_setnewkey01', 		1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getbuildnumber01',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_checkkey01',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_checkdate01',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getupdatedate',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_getkey',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_userinfo',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_getexpdate',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_getenddate',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_get_obj_access',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_setkey',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_getconfig',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_smeta_getsubconfig',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'ExtractKeyParams',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'CreateSignature',1

		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_checkdigt01',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getvernumber',1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_decrypt_r',1

		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_ed2sql',		1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_sklonstr',		1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_sklonadd',		1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getlicenseinfo01',  1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getlicenseinfo02',  1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getxmlver',1


		-- old
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_renew2'
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_gethash'
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_setkey2'
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_login',		1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getlicenseinfo3',	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_iskeyavail',	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_addon2',		1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_addonfun',		1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_checkdigt',		1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_setusertype'
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getusertype',	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_setgrpctrl'
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getgrpctrl',	1
		-- Obsolete
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getbuildnumber',	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getlicenseinfo',	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getlicenseinfo2',	1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_addon',		1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_addoninst'
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_renew'
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_sys_doc',		1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getst',		1
		EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getcloseddoc',	1

	END

-- Deprecated
SET @stmt = N'
		IF OBJECTPROPERTY(OBJECT_ID(@proc),''IsExtendedProc'') = 1
		EXECUTE SP_DROPEXTENDEDPROC @proc
'
SET @params = N'@proc VARCHAR(64)'
EXECUTE SP_EXECUTESQL @stmt, @params,'xp_t_info'
EXECUTE SP_EXECUTESQL @stmt, @params,'xp_t_info2'
EXECUTE SP_EXECUTESQL @stmt, @params,'xp_a_create_sys_table'
EXECUTE SP_EXECUTESQL @stmt, @params,'xp_sp_check_change'
EXECUTE SP_EXECUTESQL @stmt, @params,'xp_getkey'
EXECUTE SP_EXECUTESQL @stmt, @params,'xp_setkey'
EXECUTE SP_EXECUTESQL @stmt, @params,'xp_userinfo'
EXECUTE SP_EXECUTESQL @stmt, @params,'xp_checkdig'

GO
